UNIT Unit20;

INTERFACE

USES
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, StdCtrls, ExtCtrls, TeeProcs, Chart, Series;

TYPE
  TForm20 = CLASS(TForm)
    Panel1: TPanel;
    CrashBtn: TButton;
    OKBtn: TButton;
    ClearBtn: TButton;
    AddXYBtn: TButton;
    AddSeriesBtn: TButton;
    RestartBtn: TButton;
    Chart1: TChart;
    PROCEDURE FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CrashBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure AddXYBtnClick(Sender: TObject);
    procedure AddSeriesBtnClick(Sender: TObject);
    procedure RestartBtnClick(Sender: TObject);
  PRIVATE
    { Private declarations }
    FSeries: TFastLineSeries;
  PUBLIC
    { Public declarations }
  END;

VAR
  Form20: TForm20;

IMPLEMENTATION

{$R *.dfm}

procedure TForm20.AddSeriesBtnClick(Sender: TObject);
VAR
  _series: TFastLineSeries;
BEGIN
  _series := TFastLineSeries.Create(NIL);
  // if DrawAllPoints is set to false then an exception is thrown
  // when the DataSource(FSeries) has less than 2 points
  _series.DrawAllPoints := false;
  _series.DataSource := FSeries;

  Chart1.AddSeries(_series);
end;

procedure TForm20.AddXYBtnClick(Sender: TObject);
begin
  FSeries.AddXY(FSeries.Count, FSeries.Count);
end;

procedure TForm20.ClearBtnClick(Sender: TObject);
begin
  FSeries.Clear;
end;

procedure TForm20.CrashBtnClick(Sender: TObject);
begin
  RestartBtn.Click;

  AddXYBtn.Click;

  AddSeriesBtn.Click;
end;

procedure TForm20.OKBtnClick(Sender: TObject);
begin
  RestartBtn.Click;

  AddXYBtn.Click;
  AddXYBtn.Click;

  AddSeriesBtn.Click;
end;

procedure TForm20.RestartBtnClick(Sender: TObject);
begin
  Chart1.ClearChart;
  ClearBtn.Click;
end;

PROCEDURE TForm20.FormCreate(Sender: TObject);
BEGIN
  FSeries := TFastLineSeries.Create(NIL);
END;

procedure TForm20.FormDestroy(Sender: TObject);
begin
  FSeries.Free;
end;

END.
